/*------------------------------------------------------------------------------
 bin/djv_convert/etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "etc.h"

namespace djv_convert {

Str label_image(const djv_image::Info & in, const djv_image::Time & time)
{
  return str::Format("%%x%%:%% %% %%@%%").
    arg(in.size.x).arg(in.size.y).arg(aspect(in.size), 0, -2).
    arg(djv_image::pixel::label_pixel()[in.pixel]).
    arg(djv_image::time::units_to_str(time.list.size(), time.speed)).
    arg(djv_image::time::speed_to_float(time.speed));
}

const Str
  label_timeout = "Timeout...",
  label_estimate = "[%%%] Estimated = %% (%% Frames/Second)",
  label_complete = "[100%] ",
  label_elapsed = "Elapsed = %%";

const Str
  error_cmdln_input = "Input",
  error_cmdln_output = "Output";

}

