/*------------------------------------------------------------------------------
 bin/djv_view/shortcut_prefs.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "app.h"
#include "shortcut.h"
#include <djv_ui/prefs.h>

namespace djv_view {
namespace shortcut {

Prefs::Prefs()
{
  using djv_ui::shortcut::Shortcut;
  
  Str tmp;
  
  const List<Str> & label_shortcut = shortcut::label_shortcut();
  _shortcut += Shortcut(label_shortcut[EXIT], FL_CTRL + 'q');
  _shortcut += Shortcut(label_shortcut[FILE_OPEN], FL_CTRL + 'o');
  _shortcut += Shortcut(label_shortcut[FILE_RELOAD], FL_CTRL + 'r');
  _shortcut += Shortcut(label_shortcut[FILE_SAVE], FL_CTRL + 's');
  _shortcut += Shortcut(label_shortcut[FILE_SAVE_FRAME],
    FL_SHIFT + FL_CTRL + 's');
  _shortcut += Shortcut(label_shortcut[FILE_CLOSE], FL_CTRL + 'w');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_DEFAULT], FL_CTRL + '`');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_1], FL_CTRL + '1');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_2], FL_CTRL + '2');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_3], FL_CTRL + '3');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_4], FL_CTRL + '4');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_5], FL_CTRL + '5');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_6], FL_CTRL + '6');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_7], FL_CTRL + '7');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_8], FL_CTRL + '8');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_9], FL_CTRL + '9');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_10], FL_CTRL + '0');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_PREV], FL_CTRL + '-');
  _shortcut += Shortcut(label_shortcut[FILE_LAYER_NEXT], FL_CTRL + '=');
  _shortcut += Shortcut(label_shortcut[FILE_PROXY_NONE], '6');
  _shortcut += Shortcut(label_shortcut[FILE_PROXY_1_2], '7');
  _shortcut += Shortcut(label_shortcut[FILE_PROXY_1_4], '8');
  _shortcut += Shortcut(label_shortcut[FILE_PROXY_1_8], '9');
  _shortcut += Shortcut(label_shortcut[WINDOW_NEW], FL_CTRL + 'n');
  _shortcut += Shortcut(label_shortcut[WINDOW_COPY], FL_CTRL + 'c');
  _shortcut += Shortcut(label_shortcut[WINDOW_CLOSE], FL_CTRL + 'e');
  _shortcut += Shortcut(label_shortcut[WINDOW_FIT], 'f');
  _shortcut += Shortcut(label_shortcut[WINDOW_FULLSCREEN], 'u');
  _shortcut += Shortcut(label_shortcut[WINDOW_TOOLBAR], 't');
  _shortcut += Shortcut(label_shortcut[WINDOW_PLAYBAR], 'y');
  _shortcut += Shortcut(label_shortcut[VIEW_LEFT], 0);
  _shortcut += Shortcut(label_shortcut[VIEW_RIGHT], 0);
  _shortcut += Shortcut(label_shortcut[VIEW_UP], 0);
  _shortcut += Shortcut(label_shortcut[VIEW_DOWN], 0);
  _shortcut += Shortcut(label_shortcut[VIEW_CENTER], FL_Insert);
  _shortcut += Shortcut(label_shortcut[VIEW_ZOOM_IN], '=');
  _shortcut += Shortcut(label_shortcut[VIEW_ZOOM_OUT], '-');
  _shortcut += Shortcut(label_shortcut[VIEW_ZOOM_RESET], '0');
  _shortcut += Shortcut(label_shortcut[VIEW_RESET], FL_Delete);
  _shortcut += Shortcut(label_shortcut[VIEW_FIT], FL_BackSpace);
  _shortcut += Shortcut(label_shortcut[VIEW_HUD], 'h');
  _shortcut += Shortcut(label_shortcut[IMAGE_FRAME_STORE], 'e');
  _shortcut += Shortcut(label_shortcut[IMAGE_FRAME_STORE_LOAD], FL_SHIFT + 'e');
  _shortcut += Shortcut(label_shortcut[IMAGE_MIRROR_HORIZONTAL], FL_F + 1);
  _shortcut += Shortcut(label_shortcut[IMAGE_MIRROR_VERTICAL], FL_F + 2);
  _shortcut += Shortcut(label_shortcut[IMAGE_SCALE_NONE], FL_F + 5);
  _shortcut += Shortcut(label_shortcut[IMAGE_SCALE_16_9], FL_F + 6);
  _shortcut += Shortcut(label_shortcut[IMAGE_SCALE_1_85], FL_F + 7);
  _shortcut += Shortcut(label_shortcut[IMAGE_SCALE_2_35], FL_F + 8);
  _shortcut += Shortcut(label_shortcut[IMAGE_ROTATE_0], FL_F + 9);
  _shortcut += Shortcut(label_shortcut[IMAGE_ROTATE_90], FL_F + 10);
  _shortcut += Shortcut(label_shortcut[IMAGE_ROTATE_180], FL_F + 11);
  _shortcut += Shortcut(label_shortcut[IMAGE_ROTATE_270], FL_F + 12);
  _shortcut += Shortcut(label_shortcut[IMAGE_PROFILE], 'r');
  _shortcut += Shortcut(label_shortcut[IMAGE_CHANNEL_DEFAULT], '`');
  _shortcut += Shortcut(label_shortcut[IMAGE_CHANNEL_1], '1');
  _shortcut += Shortcut(label_shortcut[IMAGE_CHANNEL_2], '2');
  _shortcut += Shortcut(label_shortcut[IMAGE_CHANNEL_3], '3');
  _shortcut += Shortcut(label_shortcut[IMAGE_CHANNEL_4], '4');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY], 'd');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_RESET], FL_SHIFT + '`');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_1], FL_SHIFT + '1');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_2], FL_SHIFT + '2');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_3], FL_SHIFT + '3');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_4], FL_SHIFT + '4');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_5], FL_SHIFT + '5');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_6], FL_SHIFT + '6');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_7], FL_SHIFT + '7');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_8], FL_SHIFT + '8');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_9], FL_SHIFT + '9');
  _shortcut += Shortcut(label_shortcut[IMAGE_DISPLAY_10], FL_SHIFT + '0');
  _shortcut += Shortcut(label_shortcut[IMAGE_MAGNIFY], 'm');
  _shortcut += Shortcut(label_shortcut[IMAGE_SAMPLE], 's');
  _shortcut += Shortcut(label_shortcut[IMAGE_HISTOGRAM], 'g');
  _shortcut += Shortcut(label_shortcut[IMAGE_INFO], 'n');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_STOP], 'k');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_FORWARD], 'l');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_REVERSE], 'j');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_START], FL_Up);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_START_ABS], FL_SHIFT + FL_Up);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_END], FL_Down);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_END_ABS], FL_SHIFT + FL_Down);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_PREV], FL_Left);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_PREV_X10],
    FL_SHIFT + FL_Left);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_PREV_X100],
    FL_ALT + FL_Left);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_NEXT], FL_Right);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_NEXT_X10],
    FL_SHIFT + FL_Right);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_NEXT_X100],
    FL_ALT + FL_Right);
  _shortcut += Shortcut(label_shortcut[PLAYBACK_IN_MARK], 'i');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_IN_RESET], FL_SHIFT + 'i');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_OUT_MARK], 'o');
  _shortcut += Shortcut(label_shortcut[PLAYBACK_OUT_RESET], FL_SHIFT + 'o');
  
  djv_ui::prefs::Prefs prefs(djv_ui::prefs::prefs(), "shortcut");
  for (uint i = 0; i < _shortcut.size(); ++i)
    if (prefs.get(_shortcut[i].name, &tmp))
      djv_ui::shortcut::serialize(&tmp, &_shortcut[i].value);
}

Prefs::~Prefs()
{
  djv_ui::prefs::Prefs prefs(djv_ui::prefs::prefs(), "shortcut");
  for (uint i = 0; i < _shortcut.size(); ++i)
    prefs.set(_shortcut[i].name,
      djv_ui::shortcut::serialize(_shortcut[i].value));
}

void Prefs::shortcut(const List<djv_ui::shortcut::Shortcut> & in)
{
  if (in == _shortcut) return;
  
  _shortcut = in;
  
  app()->window_update();
}

const List<djv_ui::shortcut::Shortcut> & Prefs::shortcut() const
  { return _shortcut; }

}
}
