/*------------------------------------------------------------------------------
 bin/djv_view/window_etc.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include "window.h"

namespace djv_view {
namespace window {

double resize_max(RESIZE_MAX in)
{
  switch (in)
  {
    case RESIZE_MAX_25: return 0.25;
    case RESIZE_MAX_50: return 0.50;
    case RESIZE_MAX_75: return 0.75;
    default: break;
  }
  return 1.0;
}

DJV_STR_OPERATOR_SET(RESIZE_MAX, label_resize_max())
DJV_STR_OPERATOR_GET(RESIZE_MAX, label_resize_max())

const List<Str> & label_resize_max()
{
  static const List<Str> data = List<Str>() <<
    "None" <<
    "25%" <<
    "50%" <<
    "75%";
  return data;
}

const Str
  menu_title = "&Window",
  menu_new = "New",
  menu_copy = "Copy",
  menu_close = "Close",
  menu_fit = "Fit",
  menu_fullscreen = "Fullscreen",
  menu_toolbar = "Toolbar",
  menu_playbar = "Playbar";

const Str
  tooltip_new = "Create a new window.\nKeyboard shortcut: %%",
  tooltip_copy = "Copy window.\nKeyboard shortcut: %%",
  tooltip_close = "Close window.\nKeyboard shortcut: %%",
  tooltip_fit = "Fit window to image.\nKeyboard shortcut: %%",
  tooltip_fullscreen = "Fullscreen mode.\nKeyboard shortcut: %%";

const Str
  prefs_title = "Window",
  prefs_resize_group = "Resizing",
  prefs_resize_fit = "Resize window to fit image.",
  prefs_resize_max = "Maximum percentage of screen:",
  prefs_controls_group = "Controls",
  prefs_toolbar = "Show toolbar controls.",
  prefs_playbar = "Show playbar controls.";

}
}

