/*------------------------------------------------------------------------------
 include/djv_ui/app_dialog.h
 
 Application Dialogs
 -------------------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_APP_DIALOG_H
#define DJV_UI_APP_DIALOG_H

#include <djv_ui/dialog.h>

namespace djv_ui {
namespace app_dialog {

//------------------------------------------------------------------------------
// Information Dialog

class Info : public dialog::Base
{
public:
  
  Info();
  ~Info();
  
  // Widget.
  
  void show();
  
private:
  
  DJV_CALLBACK(Info, close_callback, bool);
  
  struct _Info;
  std::auto_ptr<_Info> _p;
};

//------------------------------------------------------------------------------
// About Dialog

class About : public dialog::Base
{
public:
  
  About();
  ~About();
  
  // Widget.
  
  void show();
  
private:
  
  DJV_CALLBACK(About, close_callback, bool);
  
  struct _About;
  std::auto_ptr<_About> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_info,
  label_about;

//------------------------------------------------------------------------------
// Global

class Global
{
public:

  Global();
  ~Global();

  Info * info() const;
  About * about() const;

private:

  widget::Auto_Ptr<Info> _info;
  widget::Auto_Ptr<About> _about;
};

Global * global();

}
}

#endif

