/*------------------------------------------------------------------------------
 include/djv_ui/columns.h
 
 Columns Widget
 --------------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_COLUMNS_H
#define DJV_UI_COLUMNS_H

#include <djv_ui/widget.h>

namespace djv_ui {
namespace columns {

//------------------------------------------------------------------------------
// Widget

class Widget : public widget::Widget
{
public:

  Widget();
  virtual ~Widget();
  
  // Value.
  
  void name_list(const List<Str> &);
  void size_list(const List<int> &);
  List<Str> name_list() const;
  List<int> size_list() const;
  Signal<const List<int> &> sig;
  Signal<int> action_sig;
  
  // Sorting.
  
  void sort(int);
  void sort_reverse(bool);
  int  sort() const;
  bool sort_reverse() const;
  
  // Widget.

  virtual int handle(int);
  virtual void draw();
  
  // Layout.

  virtual void dirty();
  virtual void geom(const Box2i &);
  virtual const Box2i & geom() const;
  
private:
  
  struct Column
  {
    Str name;
    int column;
    int size_hint;
  };

  static int handle_push(int, const List<Column> &);
  static int handle_drag(int, const List<Column> &);
  
  void columns_update();
  void widget_update();
  
  List<Column> _column_list;
  int _sort;
  bool _sort_reverse;
  int _push, _drag;
};

}
}

#endif

