/*------------------------------------------------------------------------------
 include/djv_ui/image_io_lut.h
 
 LUT Image I/O Widgets
 ---------------------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_IMAGE_IO_LUT_H
#define DJV_UI_IMAGE_IO_LUT_H

#include <djv_image/io_lut.h>
#include <djv_ui/image_io.h>

namespace djv_ui {
namespace image_io_lut {

//------------------------------------------------------------------------------
// Load Widget

class Load : public image_io::Load
{
public:

  Load();
  ~Load();

  plugin::Plugin * copy() const;
  const Str & name() const;
  
  void set(djv_image::io::Plugin *);

private:

  DJV_CALLBACK(Load, spec_callback, int);
  DJV_CALLBACK(Load, type_callback, int);
  
  void plugin_update();
  void widget_update();

  djv_image::io::Plugin * _plugin;
  djv_image::io_lut::Load_Option _option;
  
  struct _Load;
  std::auto_ptr<_Load> _p;
};

//------------------------------------------------------------------------------
// Save Widget

class Save : public image_io::Save
{
public:

  Save();
  ~Save();

  plugin::Plugin * copy() const;
  const Str & name() const;
  
  void set(djv_image::io::Plugin *);

private:

  DJV_CALLBACK(Save, spec_callback, int);
  
  void plugin_update();
  void widget_update();

  djv_image::io::Plugin * _plugin;
  djv_image::io_lut::Save_Option _option;
  
  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_spec_group,
  label_spec,
  label_type_group,
  label_type;

}
}

#endif

