/*------------------------------------------------------------------------------
 include/djv_ui/image_io_sgi.h
 
 SGI Image I/O Widgets
 ---------------------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_IMAGE_IO_SGI_H
#define DJV_UI_IMAGE_IO_SGI_H

#include <djv_image/io_sgi.h>
#include <djv_ui/image_io.h>

namespace djv_ui {
namespace image_io_sgi {

//------------------------------------------------------------------------------
// Save Widget

class Save : public image_io::Save
{
public:

  Save();
  ~Save();

  plugin::Plugin * copy() const;
  const Str & name() const;
  
  void set(djv_image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save, compress_callback, int);
  
  void plugin_update();
  void widget_update();

  djv_image::io::Plugin * _plugin;
  djv_image::io_sgi::Save_Option _option;

  struct _Save;
  std::auto_ptr<_Save> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_compress_group,
  label_compress;

}
}

#endif

