/*------------------------------------------------------------------------------
 include/djv_ui/messages_dialog.h
 
 Messages Dialog
 ---------------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_MESSAGES_DIALOG_H
#define DJV_UI_MESSAGES_DIALOG_H

#include <djv_ui/dialog.h>

namespace djv_ui {
namespace messages_dialog {

//------------------------------------------------------------------------------
// Dialog

class Dialog : public dialog::Base
{
public:
  
  Dialog();
  ~Dialog();
  virtual void del();

  // Value.
  
  void set(const Str &);
  void set(const Error &, const Str & = Str());
  void clear();
  
  // Widget.
  
  virtual void show();

  // Layout.
  
  virtual void dirty();
  virtual const Vec2i & size_min() const;
  
private:
  
  DJV_CALLBACK(Dialog, show_callback, bool);
  DJV_CALLBACK(Dialog, clear_callback, bool);
  DJV_CALLBACK(Dialog, close_callback, bool);
  
  void widget_update();
  void dialog_update();
  
  List<Str> _list;
  bool _show;
  Vec2i _size_min;
  
  struct _Dialog;
  std::auto_ptr<_Dialog> _p;
};

//------------------------------------------------------------------------------
// Labels

extern const Str
  label_title,
  label_clear;

extern const Str
  error_format;

//------------------------------------------------------------------------------
// Global

Dialog * global();

void message(const Str &);
void error(const Error &, const Str & = Str());

}
}

#endif

