/*------------------------------------------------------------------------------
 include/djv_ui/scroll.h
 
 Scroll Widget
 -------------

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_SCROLL_H
#define DJV_UI_SCROLL_H

#include <djv_ui/widget.h>
#include <FL/Fl_Scroll.H>

class Fl_Box;

namespace djv_ui {
namespace scroll {

//------------------------------------------------------------------------------
// Widget

class Widget : public Fl_Scroll, public widget::Base
{
public:

  Widget();
  virtual ~Widget();
  
  // Widget.
  
  virtual int handle(int);
  virtual void show();
  virtual void draw();
  
  // Layout.

  void resizable(bool);
  bool resizable() const;

  virtual void dirty();
  virtual void geom(const Box2i &);
  virtual void resize(int, int, int, int);
  virtual const Box2i & geom() const;
  virtual const Vec2i & size_min() const;
  virtual int visible() const;
  
  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::scroll::Widget"; }

private:

  bool _resizable;
  Fl_Box * _dummy_widget;
  Vec2i _size_min;
};

}
}

#endif

