/*------------------------------------------------------------------------------
 include/djv_ui/vec.h
 
 Vector Widgets
 --------------
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_VEC_H
#define DJV_UI_VEC_H

#include <djv_ui/widget.h>

namespace djv_ui {
namespace vec {

//------------------------------------------------------------------------------
// Two-Dimensional Vector Widgets

class Vec2i : public widget::Widget
{
public:

  Vec2i();
  ~Vec2i();
  
  // Value.

  void set(const djv_base::Vec2i &);
  const djv_base::Vec2i & get() const;
  Signal<const djv_base::Vec2i &> sig;
  
private:

  DJV_CALLBACK(Vec2i, widget_callback, int);
  DJV_CALLBACK(Vec2i, widget2_callback, int);
  
  void widget_update();

  djv_base::Vec2i _value, _tmp;

  struct _Vec2i;
  std::auto_ptr<_Vec2i> _p;
};

class Vec2f : public widget::Widget
{
public:

  Vec2f();
  ~Vec2f();
  
  // Value.

  void set(const djv_base::Vec2f &);
  const djv_base::Vec2f & get() const;
  Signal<const djv_base::Vec2f &> sig;

private:

  DJV_CALLBACK(Vec2f, widget_callback, double);
  DJV_CALLBACK(Vec2f, widget2_callback, double);
  
  void widget_update();

  djv_base::Vec2f _value, _tmp;

  struct _Vec2f;
  std::auto_ptr<_Vec2f> _p;
};

}
}

#endif

