/*------------------------------------------------------------------------------
 include/djv_ui/widget_.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

namespace djv_ui {
namespace widget {
  
inline const Fl_Font & Base::text_font() const { return _text_font; }
inline const Fl_Color & Base::text_color() const { return _text_color; }
inline const Str & Base::tooltip() const { return _tooltip; }
  
inline const Box2i & Base::geom() const { return Item::geom(); }
inline layout::Layout * Base::layout() const { return _layout.get(); }

template<class T>
inline Auto_Ptr<T>::Auto_Ptr()
{}

template<class T>
inline Auto_Ptr<T>::Auto_Ptr(T * in) :
  p(in)
{}

template<class T>
inline Auto_Ptr<T>::~Auto_Ptr()
{
  if (p.get())
  {
    p->del();
    p.release();
  }
}

template<class T>
inline T * Auto_Ptr<T>::get() const { return p.get(); }

template<class T>
inline T * Auto_Ptr<T>::operator -> () const { return p.get(); }
  
inline const Str & Widget::tooltip() const { return Base::tooltip(); }

inline void Widget::resize(int x, int y, int w, int h)
{
  geom(Box2i(x, y, w, h));
}
  
inline const Box2i & Widget::geom() const { return Base::geom(); }
inline int Widget::visible() const { return _visible; }
  
inline const layout::SIZE * Widget::size() const { return Base::size(); }
inline const layout::ALIGN * Widget::align() const { return Base::align(); }

}
}
