/*------------------------------------------------------------------------------
 lib/djv_base/user.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_base/user.h>
#if defined(WIN32)
#include <windows.h>
#else
#include <pwd.h>
#include <unistd.h>
#endif

namespace djv_base {
namespace user {

Str current()
{
  Str out;

#if defined(WIN32)

  // XXX TCHAR conversion?
  
  TCHAR tmp [str::cstr_size] = { 0 };
  DWORD size = str::cstr_size;
  ::GetUserName(tmp, &size);
  out = Str(tmp);

#else
  out = uid_to_str(::getuid());
#endif

  return out;
}

Str uid_to_str(uid_t in)
{
  Str out;

#if ! defined(WIN32)
  struct passwd * buf = ::getpwuid(in);
  if (buf) out = buf->pw_name;
#endif

  return out;
}

}
}
