/*------------------------------------------------------------------------------
 lib/djv_image/data_gradient.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG

#include <djv_image/image.h>

namespace djv_image {
namespace data {

void gradient(djv_image::Data * out)
{
  DJV_ASSERT(out);

  DJV_DBG_OBJ("gradient");
  
  const Info info(out->size(), pixel::L_F32);
  out->set(info);
  DJV_DBG_PRN("out = " << *out);
  
  for (int y = 0; y < info.size.y; ++y)
  {
    pixel::F32_T * p = reinterpret_cast<pixel::F32_T *>(out->data(0, y));
    
    for (int x = 0; x < info.size.x; ++x, ++p)
      *p = x / double(info.size.x - 1);
  }
}

}
}

