/*------------------------------------------------------------------------------
 lib/djv_image/glx_offscreen.h
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef _DJV_IMAGE_GLX_OFFSCREEN_H
#define _DJV_IMAGE_GLX_OFFSCREEN_H

#include "gl_offscreen.h"

namespace djv_image {
namespace gl_offscreen {

//------------------------------------------------------------------------------
// Pixel Buffer

class _Pbuffer
{
public:

  _Pbuffer();
  ~_Pbuffer();
  
  void init(const Info &, GLXFBConfig) throw (Error);
  void current() throw (Error);
  
  const Info & info() const { return _info; }
  
private:

  Info _info;
  GLXContext _context;
  GLXPbuffer _pbuffer;
};

class _Glx_Pbuffer_Factory : public _Pbuffer_Factory
{
public:

  _Glx_Pbuffer_Factory();
  ~_Glx_Pbuffer_Factory();
  
  void init() throw (Error);
  void add(_Pbuffer *);
  
  _Pbuffer * get(const Info &) throw (Error);
  
  GLXFBConfig config() const { return _config; }
  
private:

  List<_Pbuffer *> _list;
  static const int _list_max = 10;
  GLXFBConfig _config;
};

//------------------------------------------------------------------------------
// Labels

static const Str
  error_glx = "GLX",
  error_glx_fbconfig = "Frame Buffer Configuration",
  error_glx_pbuffer_create = "PBuffer Create";

}
}

#endif
