/*------------------------------------------------------------------------------
 lib/djv_image/io_cineon_etc.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_image/io_cineon.h>

namespace djv_image {
namespace io_cineon {

bool operator == (const Print & a, const Print & b)
{
  return
    a.black == b.black &&
    a.white == b.white &&
    a.gamma == b.gamma;
}

bool operator == (const Unprint & a, const Unprint & b)
{
  return
    a.black == b.black &&
    a.white == b.white &&
    a.gamma == b.gamma &&
    a.soft_clip == b.soft_clip;
}

Str & operator >> (Str & in, Print & out) throw (Str)
{
  return in >>
    out.black >>
    out.white >>
    out.gamma;
}

Str & operator << (Str & out, const Print & in)
{
  return out <<
    in.black <<
    in.white <<
    in.gamma;
}

Str & operator >> (Str & in, Unprint & out) throw (Str)
{
  return in >>
    out.black >>
    out.white >>
    out.gamma >>
    out.soft_clip;
}

Str & operator << (Str & out, const Unprint & in)
{
  return out <<
    in.black <<
    in.white <<
    in.gamma <<
    in.soft_clip;
}

DJV_STR_OPERATOR_SET(COLOR, label_color())
DJV_STR_OPERATOR_GET(COLOR, label_color())

const List<Str> & label_color()
{
  static const List<Str> data = List<Str>() <<
    "Auto" <<
    "Raw" <<
    "Print";
  return data;
}

const List<Str> & label_tag()
{
  static const List<Str> data = List<Str>() <<
    "Source Offset" <<
    "Source File" <<
    "Source Time" <<
    "Source Input Device" <<
    "Source Input Model" <<
    "Source Input Serial" <<
    "Source Input Pitch" <<
    "Source Gamma" <<
    "Film Format" <<
    "Film Frame" <<
    "Film Frame Rate" <<
    "Film Frame ID" <<
    "Film Slate";
  return data;
}

const List<Str> & label_load_option()
{
  static const List<Str> data = List<Str>() <<
    "Color" <<
    "Print";
  return data;
}

const List<Str> & label_save_option() 
{
  static const List<Str> data = List<Str>() <<
    "Color" <<
    "Print";
  return data;
}

}
}
