/*------------------------------------------------------------------------------
 lib/djv_image/io_dpx_etc.cxx
 
 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_image/io_dpx.h>

namespace djv_image {
namespace io_dpx {

DJV_STR_OPERATOR_SET(TYPE, label_type())
DJV_STR_OPERATOR_GET(TYPE, label_type())
DJV_STR_OPERATOR_SET(ENDIAN, label_endian())
DJV_STR_OPERATOR_GET(ENDIAN, label_endian())

const List<Str> & label_type()
{
  static const List<Str> data = List<Str>() <<
    "Auto" <<
    "U10";
  return data;
}

const List<Str> & label_endian()
{
  static const List<Str> data = List<Str>() <<
    "Auto" <<
    mem::label_endian();
  return data;
}

const List<Str> & label_tag()
{
  static const List<Str> data = List<Str>() <<
    "Source Offset" <<
    "Source Center" <<
    "Source Size" <<
    "Source File" <<
    "Source Time" <<
    "Source Input Device" <<
    "Source Input Serial" <<
    "Source Border" <<
    "Source Pixel Aspect" <<
    "Source Scan Size" <<
    "Film Format" <<
    "Film Frame" <<
    "Film Sequence" <<
    "Film Hold" <<
    "Film Frame Rate" <<
    "Film Shutter" <<
    "Film Frame ID" <<
    "Film Slate" <<
    "TV Interlace" <<
    "TV Field" <<
    "TV Video Signal" <<
    "TV Sample Rate" <<
    "TV Frame Rate" <<
    "TV Time Offset" <<
    "TV Gamma" <<
    "TV Black Level" <<
    "TV Black Gain" <<
    "TV Break Point" <<
    "TV White Level" <<
    "TV Integration Times";
  return data;
}

const List<Str> & label_load_option()
{
  static const List<Str> data = List<Str>() <<
    "Color" <<
    "Print";
  return data;
}

const List<Str> & label_save_option() 
{
  static const List<Str> data = List<Str>() <<
    "Color" <<
    "Print" <<
    "Type" <<
    "Endian";
  return data;
}

}
}
