/*------------------------------------------------------------------------------
 lib/djv_ui/callback.cxx

 Copyright (c) 2004-2008 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#undef DJV_DBG
//#define DJV_DBG

#include <djv_ui/callback.h>

namespace djv_ui {

Callback_Base::Callback_Base() :
  _callbacks(true)
{}

Callback_Base::~Callback_Base()
{
  del();
}

void Callback_Base::del()
{
  for (uint i = 0; i < _signal_list.size(); ++i)
    _signal_list[i]->del();
  _signal_list.clear();
  
  for (uint i = 0; i < _connect_list.size(); ++i)
    _connect_list[i]->release(this);
  _connect_list.clear();
}

void Callback_Base::signal_add(Signal_Base * in) { _signal_list += in; }

void Callback_Base::signal_del(Signal_Base * in)
{
  List<Signal_Base *>::iterator i = std::find(
    _signal_list.begin(), _signal_list.end(), in);
  if (i != _signal_list.end()) _signal_list.erase(i);
}

uint Callback_Base::signal_size() const { return _signal_list.size(); }

void Callback_Base::connect_add(Signal_Base * in) { _connect_list += in; }

void Callback_Base::connect_del(Signal_Base * in)
{
  List<Signal_Base *>::iterator i = std::find(
    _connect_list.begin(), _connect_list.end(), in);
  if (i != _connect_list.end()) _connect_list.erase(i);
}

uint Callback_Base::connect_size() const { return _connect_list.size(); }
  
void Callback_Base::callbacks(bool in)
{
  _callbacks = in;
}

bool Callback_Base::callbacks() const { return _callbacks; }

Signal_Base::~Signal_Base()
{}

}

