#define DJV_DBG

#include <djv_base/math.h>
#include <stdio.h>

using namespace djv_base;

int main(int argc, char ** argv)
{
  DJV_DBG_OBJ("math_range");
  
  typedef math::Range<int> Range;
  
  const struct Data { List<int> a; List<Range> b; } data [] =
  {
    {
      List<int>() << 1,
      List<Range>() << Range(1, 1)
    },
    {
      List<int>() << 1 << 2,
      List<Range>() << Range(1, 2)
    },
    {
      List<int>() << 1 << 2 << 3,
      List<Range>() << Range(1, 3)
    },
    {
      List<int>() << 1 << 3,
      List<Range>() << Range(1) << Range(3)
    },
    {
      List<int>() << 1 << 2 << 4,
      List<Range>() << Range(1, 2) << Range(4)
    },
    {
      List<int>() << 1 << 2 << 4 << 5,
      List<Range>() << Range(1, 2) << Range(4, 5)
    }
  };
  const int data_size = sizeof(data) / sizeof(Data);

  for (int i = 0; i < data_size; ++i)
  {
    const List<Range> tmp = math::range(data[i].a);
    DJV_DBG_PRN(tmp << " = " << data[i].b);
    DJV_ASSERT(tmp == data[i].b);
  }
  
  return 0;
}
