#define DJV_DBG

#include <djv_base/mtx.h>

using namespace djv_base;

void components()
{  
  DJV_DBG_OBJ("components");

  Mtx3f mtx3f;
  DJV_DBG_PRN("mtx3f = " << mtx3f);
}

void transpose()
{  
  DJV_DBG_OBJ("transpose");

  DJV_ASSERT(
    mtx::transpose(Mtx3f(0, 1, 2, 3, 4, 5, 6, 7, 8)) ==
      Mtx3f(0, 3, 6,
            1, 4, 7,
            2, 5, 8));
}

void translate()
{
  DJV_DBG_OBJ("translate");

  DJV_ASSERT(
    mtx::translate3f(Vec2f(1, 2)) ==
      Mtx3f(1, 0, 0,
            0, 1, 0,
            1, 2, 1));
}

void scale()
{
  DJV_DBG_OBJ("scale");

  DJV_ASSERT(
    mtx::scale3f(Vec2f(2.0, 4.0)) ==
      Mtx3f(2, 0, 0,
            0, 4, 0,
            0, 0, 1));
}

void rotate()
{
  /*DJV_DBG_OBJ("rotate");

  DJV_ASSERT(
    mtx::rotate3f(90.0) ==
      Mtx3f( 0, 1, 0,
            -1, 0, 0,
             0, 0, 1));*/
}

void comparison()
{  
  DJV_DBG_OBJ("comparison");

  DJV_ASSERT(
    Mtx3f(0, 1, 2, 3, 4, 5, 6, 7, 8) ==
      Mtx3f(0, 1, 2, 3, 4, 5, 6, 7, 8));
  DJV_ASSERT(
    Mtx3f(0, 1, 2, 3, 4, 5, 6, 7, 8) !=
      Mtx3f(8, 7, 6, 5, 4, 3, 2, 1, 0));
}

int main(int argc, char ** argv)
{
  components();
  transpose();
  translate();
  scale();
  rotate();
  comparison();

  return 0;
}

