#include <djv_ui/layout_row.h>
#include <djv_ui/label.h>
#include <djv_ui/choice.h>
#include <djv_ui/window.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, callback, int)
  {
    print(djv_base::str::Format("choice = %%").arg(in));
  }
  DJV_CALLBACK(App, callback2, int)
  {
    print(djv_base::str::Format("choice 2 = %%").arg(in));
  }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("choice", argc, argv),
  _window(0)
{
  using namespace djv_base;
  using namespace djv_ui;

  valid(true);
  
  const List<Str> data = List<Str>() <<
    "MacReady" <<
    "Blair" <<
    "Nauls" <<
    "Palmer" <<
    "Clark";

  // Widgets.
  
  choice::Widget * widget = new choice::Widget(data);
  widget->label(new label::Widget("Human:"));
  
  choice::Widget * widget2 = new choice::Widget(data);
  widget2->label(new label::Widget("Thing:"));

  _window = new djv_ui::window::Widget(name());
  
  // Layout.
  
  layout::group(List<layout::Item *>() << widget << widget2);

  Layout_V * layout = new Layout_V(_window);
  layout->add(widget);
  layout->add(widget2);
  
  // Initialize.

  _window->size(_window->size_hint());
  _window->show();

  // Callbacks.
  
  widget->sig.set(this, callback);
  widget2->sig.set(this, callback2);
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

