//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/color.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, widget_callback, const djv_image::Color &);
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::color::Swatch * _swatch;
  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("color_widget", argc, argv),
  _window(0)
{
  using namespace djv_ui;

  valid(true);
  
  color::Widget * widget = new color::Widget;
  _swatch = new color::Swatch;
  _swatch->size(layout::STRETCH, layout::STRETCH);
  _window = new window::Widget(name());
  
  Layout_H * layout = new Layout_H(_window);
  layout->add(_swatch);
  Layout_V * layout_v = new Layout_V(layout);
  layout_v->margin(0);
  layout->stretch(layout_v);
  layout_v->add(widget);
  
  _window->size(_window->size_hint());
  _window->show();
  
  widget->sig.set(this, widget_callback);
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

void App::widget_callback(const djv_image::Color & in)
{
  _swatch->set(in);
  
  print(djv_base::str::Format("value = %%").arg(djv_base::str::label(in)));
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

