#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/slider.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, widget_callback, int)
  {
    print(djv_base::str::Format("value = %%").arg(in));
  }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("slider", argc, argv),
  _window(0)
{
  using namespace djv_base;
  using namespace djv_ui;

  valid(true);
  
  slider::Int * slider = new slider::Int;
  //slider->range(0, 10);
  
  _window = new window::Widget(name());
  
  Layout_V * layout = new Layout_V(_window);
  layout->add(slider);
  
  _window->size(_window->size_hint());
  _window->show();

  slider->sig.set(this, widget_callback);
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

