#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/text.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, widget_callback, const djv_base::Str &) { print(in); }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("text", argc, argv),
  _window(0)
{
  DJV_DBG_OBJ("App::App");
  
  using namespace djv_ui;

  valid(true);
  
  text::Edit * edit = new text::Edit("Edit");
  text::Display * display = new text::Display("Display");

  _window = new window::Widget(name());

  Layout_V * layout = new Layout_V(_window);
  layout->add(edit);
  layout->add(display);
  
  _window->size(_window->size_hint());
  _window->show();

  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

