#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/label.h>
#include <djv_ui/app.h>

class App : public djv_ui::app::App
{
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  djv_ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  djv_ui::app::App("text_label", argc, argv),
  _window(0)
{
  DJV_DBG_OBJ("App::App");
  
  using namespace djv_ui;

  valid(true);
  
  label::Text * label = new label::Text(
    "one two three four five six seven eight nine ten\n"
    "\n"
    "ten nine eight seven six five four three two one");

  _window = new window::Widget(name());

  Layout_V * layout = new Layout_V(_window);
  layout->add(label);
  
  _window->size(_window->size_hint());
  _window->show();

  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

