#include "op_color.h"
#include <djv_ui/group.h>
#include <djv_ui/label.h>
#include <djv_ui/layout_row.h>
#include <djv_ui/num_float.h>

namespace glsl {
namespace op_color {

Op::Op() :
  _init(false)
{
  using namespace djv_ui;
  
  // Widgets.
  
  group::Box * brightness_group = new group::Box("Brightness");
  num::Float_Slider * brightness = new num::Float_Slider(0.0, 5.0);
  group::Box * contrast_group = new group::Box("Contrast");
  num::Float_Slider * contrast = new num::Float_Slider(0.0, 5.0);
  group::Box * saturation_group = new group::Box("Saturation");
  num::Float_Slider * saturation = new num::Float_Slider(0.0, 5.0);
  
  // Layout.
  
  Layout_V * layout = new Layout_V(this);
  layout->add(brightness_group);
  Layout_V * layout_v = new Layout_V(brightness_group);
  layout_v->add(brightness);
  layout->add(contrast_group);
  layout_v = new Layout_V(contrast_group);
  layout_v->add(contrast);
  layout->add(saturation_group);
  layout_v = new Layout_V(saturation_group);
  layout_v->add(saturation);
  layout->add_stretch();
  
  // Initialize.
  
  brightness->set(_value.brightness);
  contrast->set(_value.contrast);
  saturation->set(_value.saturation);
  
  // Callbacks.
  
  brightness->sig.set(this, brightness_callback);
  contrast->sig.set(this, contrast_callback);
  saturation->sig.set(this, saturation_callback);
}

void Op::brightness_callback(double in)
  { sig.emit((_value.brightness = in)); }
void Op::contrast_callback(double in)
  { sig.emit((_value.contrast = in)); }
void Op::saturation_callback(double in)
  { sig.emit((_value.saturation = in)); }

}
}
