#include "app.h"
#include <djv_ui/layout_row.h>

namespace misc {

App::App(int argc, char ** argv) :
  djv_ui::app::App("image_play", argc, argv)
{
  using namespace djv_base;
  
  // Command line.
  
  /*if (argc != 2)
  {
    print("usage: test_image_play (input)");
    djv_image::app::App::exit(app::EXIT_ERROR);
    return;
  }*/
  
  valid(true);
  
  _project.time = Time(0, 1000);
  _project.clip += new Clip("clip1", Time(0, 100));
  
  // Widgets.
  
  _widget = new Timeline_Widget;
  _window = new djv_ui::window::Widget(name());
  
  // Layout.
  
  djv_ui::Layout_V * layout = new djv_ui::Layout_V(_window);
  layout->margin(0);
  layout->add(_widget);
  layout->stretch(_widget);
  
  // Initialize.
  
  _widget->set(&_project);
  _window->size(_window->size_hint());
  _window->show();

  // Callbacks.
  
  _window->close_sig.set(this, exit_callback);
}

App::~App()
{
  if (_window) _window->del();
}

}

int main(int argc, char ** argv) { return misc::App(argc, argv).exec(); }
